/***************************************************************************
 *   Copyright (C) 2010 by Martin Burgemeister, Mathis Lindemann           *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UCQHELPBROWSER_H
#define UCQHELPBROWSER_H

#include <QWidget>
#include "ui/ui_ucqhelpbrowser.h"
#include <QDir>

/**
 * \class UCQHelpBrowser
 * \brief QDialog with a QTextBrowser and navigation buttons to display
 *        help files written in HTML.
 *
 * Most of this class was taken from Chapter 17 "Providing Online Help" of the
 * book<hr>
 * "C++ GUI Programming with Qt 4, Second Edition",<br>
 * Jasmin Blanchette and Mark Summerfield,<br>
 * Prentice Hall, 2008
 *
 * \author Martin Burgemeister <Martin.Burgemeister@gmx.de>,
 *         Mathis Lindemann <MathisLindemann@gmx.net>
 * \version 1.0
 * \date 16 August 2010
 *
 */
class UCQHelpBrowser: public QWidget
{

Q_OBJECT

public:
    UCQHelpBrowser  ( QWidget* = 0 );

    void jumpTo ( const QString& );

protected:
    void closeEvent ( QCloseEvent* );

private:
    /**
     * \brief Ui object.
     */
    Ui::UCQHelpBrowserClass ui_;

private slots:
    void updateWindowTitle ();
    void updateForward ( bool );
    void updateBack    ( bool );
};

#endif // UCQHELPBROWSER_H
