/***************************************************************************
 *   Copyright (C) 2010 by Martin Burgemeister, Mathis Lindemann   		   *
 *     																	   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LUASORT_H_
#define LUASORT_H_
extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}
#include "lua/Luna.h"
#include "controller/SortController.h"
#include "lua/LuaWrapper.h"
/**
 * \class LuaSort
 * \brief Example wrapper class for bachelor's thesis.
 *
 * This is an example wrapper class, that shows how to create new functions for
 * Lua.
 *
 * \author Martin Burgemeister <Martin.Burgemeister@gmx.de>,
 *         Mathis Lindemann <MathisLindemann@gmx.net>
 * \version 1.0
 * \date 16 August 2010
 * \see SortController
 */
class LuaSort : public LuaWrapper
{
public:
    LuaSort ( lua_State* );
    ~LuaSort ();

    int sort ( lua_State* );
    int sortOrder(lua_State *);
    /**
     * \brief Classname for Luna (see Luna.h)
     */
    static const char className[];
    /**
     * \brief Register of the functions.
     *
     * A List of all functions, that will be available in Lua.
     */
    static const Luna<LuaSort>::RegType Register[];

private:
    /**
     * \brief the SortController to use.
     */
    SortController* sortControl_;
};

#endif /* LUASORT_H_ */
